clear
clc

global Ir It Il etat_init wmax



% Ce fichier initialise la simulation SCAOQTN2.m

% Inerties satellite en kg-m(Donnes sous le masque)

% Ir=132;
% It=132;
% Il=7;

% Initialisation en vitesses angulaires absolues (rd/s)

v_roulis0=0;
v_tangage0=0.2; 
v_lacet0=pi/2; 

% Initialisation en position (rd)

roulis0=0;
tangage0=0.3;
lacet0=0;

% ****** CALCULS D'INITIALISATION DU VECTEUR D'ETAT ********

vp0=v_roulis0+v_lacet0*sin(tangage0);

vq0=v_lacet0*cos(tangage0)*sin(roulis0)+v_tangage0*cos(roulis0);

vr0=v_lacet0*cos(tangage0)*cos(roulis0)-v_tangage0*sin(roulis0);
   
wmax=180/pi*1.2*(vp0^2+vq0^2)^0.5;

% ---- Calcul du quaternion initial connaissant les angles initoaux

% Matrice de passage P de la base fixe  la base satellite
%  l'instant initial

Pmat(1,1)=cos(tangage0)*cos(lacet0);
Pmat(1,2)=-sin(lacet0)*cos(roulis0)+cos(lacet0)*sin(roulis0)*sin(tangage0);
Pmat(1,3)=sin(lacet0)*sin(roulis0)+cos(lacet0)*cos(roulis0)*sin(tangage0);

Pmat(2,1)=cos(tangage0)*sin(lacet0);
Pmat(2,2)=cos(lacet0)*cos(roulis0)+sin(lacet0)*sin(roulis0)*sin(tangage0);
Pmat(2,3)=-cos(lacet0)*sin(roulis0)+sin(lacet0)*cos(roulis0)*sin(tangage0);

Pmat(3,1)=-sin(tangage0);
Pmat(3,2)=sin(roulis0)*cos(tangage0);
Pmat(3,3)=cos(roulis0)*cos(tangage0);

% Calcul du quaternion initial
%
% Nous prenons toujours q0 >0 ou nul

trac=trace(Pmat);

qt00=(1+trac)^0.5/2;

qt10=(1-trac+2*Pmat(1,1))^0.5/2;

qt20=(1-trac+2*Pmat(2,2))^0.5/2;

qt30=(1-trac+2*Pmat(3,3))^0.5/2;

if abs(qt00)>1e-8, 
qt10=qt10*sign((Pmat(3,2)-Pmat(2,3))/4/qt00);
qt20=qt20*sign((Pmat(1,3)-Pmat(3,1))/4/qt00);
qt30=qt30*sign((-Pmat(1,2)+Pmat(2,1))/4/qt00);

elseif abs(qt10)>1e-8, 

qt20=qt20*sign((Pmat(1,2)+Pmat(2,1))/4/qt10);
qt30=qt30*sign((Pmat(1,3)+Pmat(3,1))/4/qt10);
qt00=qt00*sign((Pmat(3,2)-Pmat(2,3))/4/qt10);

elseif abs(qt20)>1e-8, 
qt10=qt10*sign((Pmat(1,2)+Pmat(2,1))/4/qt20);
qt30=qt30*sign((Pmat(2,3)+Pmat(3,2))/4/qt20);
qt00=qt00*sign((Pmat(1,3)-Pmat(3,1))/4/qt20);

elseif abs(qt30)>1e-8, 
qt20=qt20*sign((Pmat(3,2)+Pmat(2,3))/4/qt30);
qt10=qt10*sign((Pmat(1,3)+Pmat(3,1))/4/qt30);
qt00=qt00*sign((-Pmat(1,2)+Pmat(2,1))/4/qt30);

end

Q=[qt00 qt10 qt20 qt30]/norm([qt00 qt10 qt20 qt30]);

etat_init=[vp0 vq0 vr0 Q];

clear vp0 vq0 vr0 trac Pmat Q qt00 qt10 qt20 qt30 Q

end








